## sdpa 7.3.20

=== mumps/Makefile ===
MUMPS_VER = 5.8.1
MUMPS_TAR_FILE = mumps_${MUMPS_VER}.orig.tar.gz

SDPA_MAKEFILE = ../Makefile
# This file is automatically made by './configure' script
###################################################################
# The following variables are set from
# the arguments given to './configure' script for building SDPA
###################################################################

CC          = ${shell grep "^CC ="        ${SDPA_MAKEFILE} | cut -f2 -d=}
CFLAGS      = ${shell grep "^CFLAGS = "   ${SDPA_MAKEFILE} | cut -f2 -d=}
CXX         = ${shell grep "^CXX ="       ${SDPA_MAKEFILE} | cut -f2 -d=}
CXXFLAGS    = ${shell grep "^CXXFLAGS = " ${SDPA_MAKEFILE} | cut -f2 -d=}
FC          = ${shell grep "^FC ="        ${SDPA_MAKEFILE} | cut -f2 -d=}
FCFLAGS     = ${shell grep "^FCFLAGS = "  ${SDPA_MAKEFILE} | cut -f2 -d=}
PTHREAD_INCLUDE = ${shell grep "^PTHREAD_INCLUDE = "  ${SDPA_MAKEFILE} | cut -f2 -d=}
AR          = ${shell grep "^AR = "       ${SDPA_MAKEFILE} | cut -f2 -d=}
RANLIB      = ${shell grep "^RANLIB = "  ${SDPA_MAKEFILE} | cut -f2 -d=}

###################################################################

all: build/lib/libdmumps.a

build/lib/libdmumps.a:${MUMPS_TAR_FILE}
	rm -rf build;
	tar xzf ${MUMPS_TAR_FILE}
	# mv mumps-${MUMPS_VER}/ build;
	mv MUMPS_${MUMPS_VER}/ build;
	cd build; cp Make.inc/Makefile.inc.generic.SEQ Makefile.inc;

	cd build; echo "CC = "   ${CC}       >> Makefile.inc;
	cd build; echo "FC = "   ${FC}       >> Makefile.inc;
	cd build; echo "FL = "   ${FC}       >> Makefile.inc;
	cd build; echo "OPTC = " ${CFLAGS}  ${PTHREAD_INCLUDE} >> Makefile.inc;
	cd build; echo "OPTF = " ${FCFLAGS} -fallow-argument-mismatch ${PTHREAD_INCLUDE}  >> Makefile.inc;
	cd build; echo "OPTL = " ${FCFLAGS} ${PTHREAD_INCLUDE}  >> Makefile.inc;
	cd build; echo "LPORDDIR = "`pwd`"/PORD/lib/"     >> Makefile.inc;
	cd build; echo "IPORDDIR = "`pwd`"/PORD/include/" >> Makefile.inc;
	cd build; echo "AR = " ${AR} rv " " >> Makefile.inc;
	cd build; echo "RANLIB = " ${RANLIB} >> Makefile.inc;
	cd build ; ${MAKE} d

clean:
	@echo "##########################################################"
	@echo "If you want to rebuild mumps dir, use 'make distclean'"
	@echo "##########################################################"

${MUMPS_TAR_FILE}:
	@echo "By wget command, downloading a file from"
	@echo "http://ftp.de.debian.org/debian/pool/main/m/mumps/${MUMPS_TAR_FILE}"
	@echo "If fail, you manually put the file into " `pwd` "directory."
	wget http://ftp.de.debian.org/debian/pool/main/m/mumps/${MUMPS_TAR_FILE}

distclean: 
	rm -rf build ${MUMPS_TAR_FILE}

install: all
uninstall:

=== debian/changelog ===
sdpa (7.3.20-2) unstable; urgency=medium

  * debian/rules: Add -lquadmath only when available.
    This fixes MUMPS detection on architectures without libquadmath and
    avoids falling back to downloading MUMPS during the build. (Closes: 1124578)

 -- Makoto Yamashita <Makoto.Yamashita@comp.isct.ac.jp>  Sat, 03 Jan 2026 18:00:00 +0900

sdpa (7.3.20-1) unstable; urgency=low
  * New upstream
    + Change MUMPS from 5.7.3 to 5.8.1
    + Drop stale dependency on mumps/build/include/dmumps_root.h
  * Update debian/control and debian/rules (Closes: 1122042)

 -- Makoto Yamashita <Makoto.Yamashita@comp.isct.ac.jp>  Wed, 17 Dec 2025 09:00:00 +0900

=== debian/control ===
Source: sdpa
Section: math
Priority: optional
Maintainer: Makoto Yamashita <Makoto.Yamashita@comp.isct.ac.jp>
Build-Depends: debhelper-compat (=13), 
   pkgconf,
   automake, autoconf, gfortran,
   libopenblas-pthread-dev, libmumps-seq-dev, libscotch-dev, 
   octave-dev | liboctave-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: http://sdpa.sourceforge.net/

Package: sdpa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: High-performance package for SemiDefinite Programs
 The software SDPA (SemiDefinite Programming Algorithm) is one of the most
 efficient and stable  software packages for solving SDPs based on the
 primal-dual interior-point method.
 SDP (SemiDefinite Program) is used for financial engineering, machine
 learning, control theory, sensor network problem, quantum chemistry,
 quantum information, combinatorial optimizaiton, polynomial
 optimization, and so on.
 Further information on SDP and SDPA can be found at
 http://sdpa.sourceforge.net/

Package: libsdpa-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
   libopenblas-pthread-dev, libmumps-seq-dev, libscotch-dev
Description: Callable library and examples of SDPA
 This package provides some files [examples and callable library]
 of SDPA (SemiDefinite Programming Algorithm).
 See the information of the package 'sdpa'.
 Further information on SDP and SDPA can be found at
 http://sdpa.sourceforge.net/

Package: sdpam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
   libopenblas-pthread-dev,
   octave, libsdpa-dev
Description: Matlab/Octave interface of SDPA
 This package provides SDPA-M, Matlab/Octave interface
 of SDPA (SemiDefinite Programming Algorithm).
 See the information of the package 'sdpa'.
 To use SDPA-M on Octave, add /usr/share/sdpa/mex and /usr/lib/sdpa/mex
 to your Octave path.
 The summary of each command can be found in
 /usr/share/sdpa/mex/CommandList.txt
 The compilation by Matlab can be found at
 /usr/share/doc/sdpa/README.
 Further information on SDP and SDPA can be found at
 http://sdpa.sourceforge.net/

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE is used for test building
# export DH_VERBOSE=1

DEB_CFLAGS_MAINT_APPEND = -funroll-all-loops
DEB_CXXFLAGS_MAINT_APPEND = -funroll-all-loops
DPKG_EXPORT_BUILDFLAGS = 1
%:
	dh $@ --with autoreconf

# Add here any variable or target overrides you need.
DEB_MAKE_INSTALL_TARGET =

# DEB_MAKE_ENVVARS = CFLAGS="-funroll-all-loops" CXXFLAGS="-funroll-all-loops"
# DEB_MAKE_ENVVARS = CFLAGS="-g -O2 -Wall -fPIC -funroll-all-loops" CXXFLAGS="-g -O2 -D_REENTRANT -Wall -fPIC -funroll-all-loops" FCFLAGS="-g -O2 -Wall -fPIC -funroll-all-loops"

FCFLAGS  += -Wall -fPIC -funroll-all-loops

# For old libatlas-base-dev
DEB_CONFIGURE_EXTRA_FLAGS = --with-lapack="/usr/lib/atlas/liblapack.a" --with-blas="/usr/lib/atlas/libblas.a"
# For new libatlas-base-dev
ifeq ($(shell test -f /usr/lib/$(DEB_HOST_MULTIARCH)/atlas/libblas.a && echo 1),1)
	DEB_CONFIGURE_EXTRA_FLAGS = --with-lapack="/usr/lib/$(DEB_HOST_MULTIARCH)/liblapack.a" --with-blas="/usr/lib/$(DEB_HOST_MULTIARCH)/atlas/libblas.a"
endif
# For new libopenblas-dev
ifeq ($(shell test -f /usr/lib/$(DEB_HOST_MULTIARCH)/libopenblas.a && echo 1),1)
	DEB_CONFIGURE_EXTRA_FLAGS = --with-lapack="/usr/lib/$(DEB_HOST_MULTIARCH)/openblas/liblapack.a" --with-blas="/usr/lib/$(DEB_HOST_MULTIARCH)/openblas/libblas.a"
endif

# For new libopenblas-pthread-dev
ifeq ($(shell test -f /usr/lib/$(DEB_HOST_MULTIARCH)/openblas-pthread/libblas.a && echo 1),1)
	DEB_CONFIGURE_EXTRA_FLAGS = --with-lapack="/usr/lib/$(DEB_HOST_MULTIARCH)/openblas-pthread/liblapack.a" --with-blas="/usr/lib/$(DEB_HOST_MULTIARCH)/openblas-pthread/libblas.a"
endif

# MUMPS_LIBS="-ldmumps_seq -lsmumps_seq -lcmumps_seq -lzmumps_seq -lmumps_common_seq -lpord -lscotch -lesmumps -lgfortran -lquadmath"
QUADMATH_SO := $(shell $(FC) -print-file-name=libquadmath.so 2>/dev/null)
ifneq ($(QUADMATH_SO),libquadmath.so)
  QUADMATH_FLAG := -lquadmath
else
  QUADMATH_FLAG :=
endif
MUMPS_LIBS="-ldmumps_seq -lsmumps_seq -lcmumps_seq -lzmumps_seq -lmumps_common_seq -lpord -lscotch -lesmumps -lgfortran $(QUADMATH_FLAG)"

# "/usr/lib/$(DEB_HOST_MULTIARCH)/libdmumps_seq.a /usr/lib/$(DEB_HOST_MULTIARCH)/libmumps_common_seq.a /usr/lib/$(DEB_HOST_MULTIARCH)/libmpiseq_seq.a /usr/lib/$(DEB_HOST_MULTIARCH)/libpord_seq.a -lscotch -lesmumps"
DEB_CONFIGURE_EXTRA_FLAGS += --with-mumps-libs=$(MUMPS_LIBS)


# LIBMUMPS_VER := $(shell dpkg --status libmumps-seq-dev | awk '/^Version:/ {print $$2}' |cut -f 1 -d "-")
# LIBMUMPS_VER := $(shell dpkg --status libmumps-seq-dev  | grep ^Depends | tr " " "\n" | grep libmumps-seq | cut -f 3 -d "-")
# LIBMUMPS_VER := $(shell dpkg --status libmumps-seq-dev | awk '/^Version:/ {print $$2}' |cut -f 1 -d "-" | cut -d . -f 1-2)
# DEB_DH_GENCONTROL_ARGS_ALL = -- -Vmumps-seq:Version=$(LIBMUMPS_VER)

SDPA_DIR=$(CURDIR)/debian/sdpa
SDPAM_DIR=$(CURDIR)/debian/sdpam
LIBSDPA_DIR=$(CURDIR)/debian/libsdpa-dev
override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C mex \
	  MAKE_INCLUDE_DIR=../etc COMPILE_ENVIRONMENT=octave \
	  ALL_INCLUDE=-I../ SDPA_LIB=../libsdpa.a

# binary-post-install/sdpam::
#	cd $(SDPAM_DIR)/usr/lib/sdpa/mex/ && \
#	ln -s ../../../share/sdpa/mex/*.m .
#	cd $(SDPAM_DIR)/usr/lib/sdpa/mex/ && \
#	ln -s ../../../share/sdpa/mex/CommandList.txt .

override_dh_auto_configure:
	autoreconf -fi
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_auto_install:
	# Default install
	dh_auto_install
	# Install compiled MEX/Octave modules only if they exist (avoid dh_install failures)
	if ls mex/*.oct* >/dev/null 2>&1; then \
		install -d debian/sdpam/usr/lib/sdpa/mex/ ; \
		install -m 755 mex/*.oct* debian/sdpam/usr/lib/sdpa/mex/ ; \
	fi

override_dh_shlibdeps:
	dh_shlibdeps
	# If sdpam contains no ELF objects, dh_shlibdeps may not create debian/sdpam.substvars.
	# Create an empty shlibs:Depends to avoid dpkg-gencontrol warning.
	if [ -f debian/sdpam.substvars ]; then \
		grep -q '^shlibs:Depends=' debian/sdpam.substvars || echo 'shlibs:Depends=' >> debian/sdpam.substvars ; \
	else \
		echo 'shlibs:Depends=' > debian/sdpam.substvars ; \
	fi
